Index: palm/trunk/SOURCE/pmc_interface_mod.f90
===================================================================
--- palm/trunk/SOURCE/pmc_interface_mod.f90	(revision 1932)
+++ palm/trunk/SOURCE/pmc_interface_mod.f90	(revision 1933)
@@ -3969,7 +4013,7 @@
       REAL(wp), DIMENSION(nzb:nzt+1), INTENT(IN)    ::  r2z   !:
       
-      INTEGER(iwp), DIMENSION(nxlg:nxrg), INTENT(IN) ::  ic   !:
-      INTEGER(iwp), DIMENSION(nysg:nyng), INTENT(IN) ::  jc   !:
-      INTEGER(iwp), DIMENSION(nzb:nzt+1), INTENT(IN) ::  kc   !:
+      INTEGER(iwp), DIMENSION(nxlg:nxrg), INTENT(IN) ::  ic    !:
+      INTEGER(iwp), DIMENSION(nysg:nyng), INTENT(IN) ::  jc    !:
+      INTEGER(iwp), DIMENSION(nzb:nzt+1), INTENT(IN) ::  kc    !:
       
       CHARACTER(LEN=1), INTENT(IN) :: var   !:
@@ -4038,5 +4082,5 @@
     SUBROUTINE pmci_extrap_ifoutflow_lr( f, kb, edge, var )
 !
-!--    After the interpolation of ghost-node values for the client-domain
+!--    After the interpolation of ghost-node values for the child-domain
 !--    boundary conditions, this subroutine checks if there is a local outflow
 !--    through the boundary. In that case this subroutine overwrites the
@@ -4047,6 +4091,6 @@
        IMPLICIT NONE
 
-       CHARACTER(LEN=1),INTENT(IN) ::  edge   !:
-       CHARACTER(LEN=1),INTENT(IN) ::  var    !:
+       CHARACTER(LEN=1), INTENT(IN) ::  edge   !:
+       CHARACTER(LEN=1), INTENT(IN) ::  var    !:
 
        INTEGER(iwp) ::  i     !:
@@ -4116,5 +4160,5 @@
     SUBROUTINE pmci_extrap_ifoutflow_sn( f, kb, edge, var )
 !
-!--    After  the interpolation of ghost-node values for the client-domain
+!--    After  the interpolation of ghost-node values for the child-domain
 !--    boundary conditions, this subroutine checks if there is a local outflow
 !--    through the boundary. In that case this subroutine overwrites the
@@ -4193,5 +4237,5 @@
     SUBROUTINE pmci_extrap_ifoutflow_t( f, var )
 !
-!--    Interpolation of ghost-node values used as the client-domain boundary
+!--    Interpolation of ghost-node values used as the child-domain boundary
 !--    conditions. This subroutine handles the top boundary. It is based on
 !--    trilinear interpolation.
@@ -4208,5 +4252,5 @@
        REAL(wp) ::  vdotnor   !:
 
-       REAL(wp), DIMENSION(nzb:nzt+1,nys-nbgp:nyn+nbgp,nxl-nbgp:nxr+nbgp),     &
+       REAL(wp), DIMENSION(nzb:nzt+1,nys-nbgp:nyn+nbgp,nxl-nbgp:nxr+nbgp),      &
                  INTENT(INOUT) ::  f   !:
      
@@ -4241,8 +4285,8 @@
 
 
-    SUBROUTINE pmci_anterp_tophat( f, fc, kct, ifl, ifu, jfl, jfu, kfl, kfu,   &
+    SUBROUTINE pmci_anterp_tophat( f, fc, kct, ifl, ifu, jfl, jfu, kfl, kfu,    &
                                    ijfc, var )
 !
-!--    Anterpolation of internal-node values to be used as the server-domain
+!--    Anterpolation of internal-node values to be used as the parent-domain
 !--    values. This subroutine is based on the first-order numerical
 !--    integration of the fine-grid values contained within the coarse-grid
@@ -4296,27 +4340,43 @@
 !--    Note that kcb is simply zero and kct enters here as a parameter and it is
 !--    determined in pmci_init_anterp_tophat
-       IF ( nest_bound_l )  THEN
-          IF ( var == 'u' )  THEN
-             iclp = icl + nhll + 1
-          ELSE
+
+       IF ( nesting_mode == 'vertical' )  THEN
+          IF ( nest_bound_l )  THEN
              iclp = icl + nhll
           ENDIF
-       ENDIF
-       IF ( nest_bound_r )  THEN
-          icrm = icr - nhlr
-       ENDIF
-
-       IF ( nest_bound_s )  THEN
-          IF ( var == 'v' )  THEN
-             jcsp = jcs + nhls + 1
-          ELSE
+          IF ( nest_bound_r ) THEN
+             icrm = icr - nhlr
+          ENDIF
+          IF ( nest_bound_s )  THEN
              jcsp = jcs + nhls
           ENDIF
-       ENDIF
-       IF ( nest_bound_n )  THEN
-          jcnm = jcn - nhln
-       ENDIF
-       kcb = 0
-
+          IF ( nest_bound_n )  THEN
+             jcnm = jcn - nhln
+          ENDIF
+       ELSE
+          IF ( nest_bound_l )  THEN
+             IF ( var == 'u' )  THEN
+                iclp = icl + nhll + 1
+             ELSE
+                iclp = icl + nhll
+             ENDIF
+          ENDIF
+          IF ( nest_bound_r )  THEN
+             icrm = icr - nhlr
+          ENDIF
+
+          IF ( nest_bound_s )  THEN
+             IF ( var == 'v' )  THEN
+                jcsp = jcs + nhls + 1
+             ELSE
+                jcsp = jcs + nhls
+             ENDIF
+          ENDIF
+          IF ( nest_bound_n )  THEN
+             jcnm = jcn - nhln
+          ENDIF
+          kcb = 0
+       ENDIF
+       
 !
 !--    Note that ii, jj, and kk are coarse-grid indices and i,j, and k 
@@ -4349,5 +4409,5 @@
                 ENDIF
 
-                fc(kk,jj,ii) = ( 1.0_wp - fra ) * fc(kk,jj,ii) +               &
+                fc(kk,jj,ii) = ( 1.0_wp - fra ) * fc(kk,jj,ii) +                &
                                fra * cellsum / REAL( nfc, KIND = wp )
 
@@ -4359,5 +4419,5 @@
 
 #endif
- END SUBROUTINE pmci_client_datatrans
+ END SUBROUTINE pmci_child_datatrans
 
 END MODULE pmc_interface
Index: palm/trunk/SOURCE/pmc_mpi_wrapper_mod.f90
===================================================================
--- palm/trunk/SOURCE/pmc_mpi_wrapper_mod.f90	(revision 1932)
+++ palm/trunk/SOURCE/pmc_mpi_wrapper_mod.f90	(revision 1933)
@@ -1,5 +1,5 @@
  MODULE pmc_mpi_wrapper
 
-!--------------------------------------------------------------------------------!
+!-------------------------------------------------------------------------------!
 ! This file is part of PALM.
 !
@@ -16,14 +16,17 @@
 !
 ! Copyright 1997-2016 Leibniz Universitaet Hannover
-!--------------------------------------------------------------------------------!
+!-------------------------------------------------------------------------------!
 !
 ! Current revisions:
 ! ------------------
 ! 
-!
+! 
 ! Former revisions:
 ! -----------------
 ! $Id$
 !
+! 1901 2016-05-04 15:39:38Z raasch
+! Code clean up. The words server/client changed to parent/child. 
+!
 ! 1900 2016-05-04 15:27:53Z raasch
 ! re-formatted to match PALM style
@@ -50,5 +53,5 @@
 !
 ! MPI Wrapper of Palm Model Coupler
-!------------------------------------------------------------------------------!
+!-------------------------------------------------------------------------------!
 
 #if defined( __parallel )
@@ -62,6 +65,6 @@
 
     USE kinds
-    USE pmc_handle_communicator,                                               &
-        ONLY: m_model_comm, m_model_rank, m_to_server_comm, m_to_client_comm
+    USE pmc_handle_communicator,                                                &
+        ONLY: m_model_comm, m_model_rank, m_to_parent_comm, m_to_child_comm
 
     IMPLICIT NONE
@@ -70,33 +73,33 @@
     SAVE
 
-    INTERFACE pmc_send_to_server
-       MODULE PROCEDURE pmc_send_to_server_integer
-       MODULE PROCEDURE pmc_send_to_server_integer_2
-       MODULE PROCEDURE pmc_send_to_server_real_r1
-       MODULE PROCEDURE pmc_send_to_server_real_r2
-       MODULE PROCEDURE pmc_send_to_server_real_r3
-    END INTERFACE pmc_send_to_server
-
-    INTERFACE pmc_recv_from_server
-       MODULE PROCEDURE pmc_recv_from_server_integer
-       MODULE PROCEDURE pmc_recv_from_server_real_r1
-       MODULE PROCEDURE pmc_recv_from_server_real_r2
-       MODULE PROCEDURE pmc_recv_from_server_real_r3
-    END INTERFACE pmc_recv_from_server
-
-    INTERFACE pmc_send_to_client
-       MODULE PROCEDURE pmc_send_to_client_integer
-       MODULE PROCEDURE pmc_send_to_client_real_r1
-       MODULE PROCEDURE pmc_send_to_client_real_r2
-       MODULE PROCEDURE pmc_send_to_client_real_r3
-    END INTERFACE pmc_send_to_client
-
-    INTERFACE pmc_recv_from_client
-       MODULE PROCEDURE pmc_recv_from_client_integer
-       MODULE PROCEDURE pmc_recv_from_client_integer_2
-       MODULE PROCEDURE pmc_recv_from_client_real_r1
-       MODULE PROCEDURE pmc_recv_from_client_real_r2
-       MODULE PROCEDURE pmc_recv_from_client_real_r3
-    END INTERFACE pmc_recv_from_client
+    INTERFACE pmc_send_to_parent
+       MODULE PROCEDURE pmc_send_to_parent_integer
+       MODULE PROCEDURE pmc_send_to_parent_integer_2
+       MODULE PROCEDURE pmc_send_to_parent_real_r1
+       MODULE PROCEDURE pmc_send_to_parent_real_r2
+       MODULE PROCEDURE pmc_send_to_parent_real_r3
+    END INTERFACE pmc_send_to_parent
+
+    INTERFACE pmc_recv_from_parent
+       MODULE PROCEDURE pmc_recv_from_parent_integer
+       MODULE PROCEDURE pmc_recv_from_parent_real_r1
+       MODULE PROCEDURE pmc_recv_from_parent_real_r2
+       MODULE PROCEDURE pmc_recv_from_parent_real_r3
+    END INTERFACE pmc_recv_from_parent
+
+    INTERFACE pmc_send_to_child
+       MODULE PROCEDURE pmc_send_to_child_integer
+       MODULE PROCEDURE pmc_send_to_child_real_r1
+       MODULE PROCEDURE pmc_send_to_child_real_r2
+       MODULE PROCEDURE pmc_send_to_child_real_r3
+    END INTERFACE pmc_send_to_child
+
+    INTERFACE pmc_recv_from_child
+       MODULE PROCEDURE pmc_recv_from_child_integer
+       MODULE PROCEDURE pmc_recv_from_child_integer_2
+       MODULE PROCEDURE pmc_recv_from_child_real_r1
+       MODULE PROCEDURE pmc_recv_from_child_real_r2
+       MODULE PROCEDURE pmc_recv_from_child_real_r3
+    END INTERFACE pmc_recv_from_child
 
     INTERFACE pmc_bcast
@@ -118,6 +121,6 @@
     END INTERFACE pmc_time
 
-    PUBLIC pmc_alloc_mem, pmc_bcast, pmc_inter_bcast, pmc_recv_from_client,    &
-           pmc_recv_from_server, pmc_send_to_client, pmc_send_to_server,       &
+    PUBLIC pmc_alloc_mem, pmc_bcast, pmc_inter_bcast, pmc_recv_from_child,      &
+           pmc_recv_from_parent, pmc_send_to_child, pmc_send_to_parent,         &
            pmc_time
 
@@ -125,5 +128,5 @@
 
 
- SUBROUTINE pmc_send_to_server_integer( buf, n, server_rank, tag, ierr )
+ SUBROUTINE pmc_send_to_parent_integer( buf, n, parent_rank, tag, ierr )
 
     IMPLICIT NONE
@@ -131,17 +134,17 @@
     INTEGER, DIMENSION(:), INTENT(IN) ::  buf          !<
     INTEGER, INTENT(IN)               ::  n            !<
-    INTEGER, INTENT(IN)               ::  server_rank  !<
+    INTEGER, INTENT(IN)               ::  parent_rank  !<
     INTEGER, INTENT(IN)               ::  tag          !<
     INTEGER, INTENT(OUT)              ::  ierr         !<
 
     ierr = 0
-    CALL MPI_SEND( buf, n, MPI_INTEGER, server_rank, tag, m_to_server_comm,    &
+    CALL MPI_SEND( buf, n, MPI_INTEGER, parent_rank, tag, m_to_parent_comm,     &
                    ierr)
 
- END SUBROUTINE pmc_send_to_server_integer
-
-
-
- SUBROUTINE pmc_recv_from_server_integer( buf, n, server_rank, tag, ierr )
+ END SUBROUTINE pmc_send_to_parent_integer
+
+
+
+ SUBROUTINE pmc_recv_from_parent_integer( buf, n, parent_rank, tag, ierr )
 
     IMPLICIT NONE
@@ -149,17 +152,17 @@
     INTEGER, DIMENSION(:), INTENT(OUT) ::  buf          !<
     INTEGER, INTENT(IN)                ::  n            !<
-    INTEGER, INTENT(IN)                ::  server_rank  !<
+    INTEGER, INTENT(IN)                ::  parent_rank  !<
     INTEGER, INTENT(IN)                ::  tag          !<
     INTEGER, INTENT(OUT)               ::  ierr         !<
 
     ierr = 0
-    CALL MPI_RECV( buf, n, MPI_INTEGER, server_rank, tag, m_to_server_comm,    &
+    CALL MPI_RECV( buf, n, MPI_INTEGER, parent_rank, tag, m_to_parent_comm,     &
                    MPI_STATUS_IGNORE, ierr )
 
- END SUBROUTINE pmc_recv_from_server_integer
-
-
-
- SUBROUTINE pmc_send_to_server_integer_2( buf, n, server_rank, tag, ierr )
+ END SUBROUTINE pmc_recv_from_parent_integer
+
+
+
+ SUBROUTINE pmc_send_to_parent_integer_2( buf, n, parent_rank, tag, ierr )
 
     IMPLICIT NONE
@@ -167,17 +170,17 @@
     INTEGER, DIMENSION(:,:), INTENT(IN) :: buf          !<
     INTEGER, INTENT(IN)                 :: n            !<
-    INTEGER, INTENT(IN)                 :: server_rank  !<
+    INTEGER, INTENT(IN)                 :: parent_rank  !<
     INTEGER, INTENT(IN)                 :: tag          !<
     INTEGER, INTENT(OUT)                :: ierr         !<
 
     ierr = 0
-    CALL MPI_SEND( buf, n, MPI_INTEGER, server_rank, tag, m_to_server_comm,    &
+    CALL MPI_SEND( buf, n, MPI_INTEGER, parent_rank, tag, m_to_parent_comm,     &
                    ierr )
 
- END SUBROUTINE pmc_send_to_server_integer_2
-
-
-
- SUBROUTINE pmc_send_to_server_real_r1( buf, n, server_rank, tag, ierr )
+ END SUBROUTINE pmc_send_to_parent_integer_2
+
+
+
+ SUBROUTINE pmc_send_to_parent_real_r1( buf, n, parent_rank, tag, ierr )
 
     IMPLICIT NONE
@@ -185,16 +188,16 @@
     REAL(wp), DIMENSION(:), INTENT(IN) ::  buf          !<
     INTEGER, INTENT(IN)                ::  n            !<
-    INTEGER, INTENT(IN)                ::  server_rank  !<
+    INTEGER, INTENT(IN)                ::  parent_rank  !<
     INTEGER, INTENT(IN)                ::  tag          !<
     INTEGER, INTENT(OUT)               ::  ierr         !<
 
     ierr = 0
-    CALL MPI_SEND( buf, n, MPI_REAL, server_rank, tag, m_to_server_comm, ierr )
-
- END SUBROUTINE pmc_send_to_server_real_r1
-
-
-
- SUBROUTINE pmc_recv_from_server_real_r1( buf, n, server_rank, tag, ierr )
+    CALL MPI_SEND( buf, n, MPI_REAL, parent_rank, tag, m_to_parent_comm, ierr )
+
+ END SUBROUTINE pmc_send_to_parent_real_r1
+
+
+
+ SUBROUTINE pmc_recv_from_parent_real_r1( buf, n, parent_rank, tag, ierr )
 
     IMPLICIT NONE
@@ -202,17 +205,17 @@
     REAL(wp), DIMENSION(:), INTENT(OUT) ::  buf          !<
     INTEGER, INTENT(IN)                 ::  n            !<
-    INTEGER, INTENT(IN)                 ::  server_rank  !<
+    INTEGER, INTENT(IN)                 ::  parent_rank  !<
     INTEGER, INTENT(IN)                 ::  tag          !<
     INTEGER, INTENT(OUT)                ::  ierr         !<
 
     ierr = 0
-    CALL MPI_RECV( buf, n, MPI_REAL, server_rank, tag, m_to_server_comm,       &
+    CALL MPI_RECV( buf, n, MPI_REAL, parent_rank, tag, m_to_parent_comm,        &
                    MPI_STATUS_IGNORE, ierr )
 
- END SUBROUTINE pmc_recv_from_server_real_r1
-
-
-
- SUBROUTINE pmc_send_to_server_real_r2( buf, n, server_rank, tag, ierr )
+ END SUBROUTINE pmc_recv_from_parent_real_r1
+
+
+
+ SUBROUTINE pmc_send_to_parent_real_r2( buf, n, parent_rank, tag, ierr )
 
     IMPLICIT NONE
@@ -220,15 +223,15 @@
     REAL(wp), DIMENSION(:,:), INTENT(IN) ::  buf          !<
     INTEGER, INTENT(IN)                  ::  n            !<
-    INTEGER, INTENT(IN)                  ::  server_rank  !<
+    INTEGER, INTENT(IN)                  ::  parent_rank  !<
     INTEGER, INTENT(IN)                  ::  tag          !<
     INTEGER, INTENT(OUT)                 ::  ierr         !<
 
     ierr = 0
-    CALL MPI_SEND( buf, n, MPI_REAL, server_rank, tag, m_to_server_comm, ierr )
-
- END SUBROUTINE pmc_send_to_server_real_r2
-
-
- SUBROUTINE pmc_recv_from_server_real_r2( buf, n, server_rank, tag, ierr )
+    CALL MPI_SEND( buf, n, MPI_REAL, parent_rank, tag, m_to_parent_comm, ierr )
+
+ END SUBROUTINE pmc_send_to_parent_real_r2
+
+
+ SUBROUTINE pmc_recv_from_parent_real_r2( buf, n, parent_rank, tag, ierr )
 
     IMPLICIT NONE
@@ -236,17 +239,17 @@
     REAL(wp), DIMENSION(:,:), INTENT(OUT) ::  buf          !<
     INTEGER, INTENT(IN)                   ::  n            !<
-    INTEGER, INTENT(IN)                   ::  server_rank  !<
+    INTEGER, INTENT(IN)                   ::  parent_rank  !<
     INTEGER, INTENT(IN)                   ::  tag          !<
     INTEGER, INTENT(OUT)                  ::  ierr         !<
 
     ierr = 0
-    CALL MPI_RECV( buf, n, MPI_REAL, server_rank, tag, m_to_server_comm,       &
+    CALL MPI_RECV( buf, n, MPI_REAL, parent_rank, tag, m_to_parent_comm,        &
                    MPI_STATUS_IGNORE, ierr )
 
- END SUBROUTINE pmc_recv_from_server_real_r2
-
-
-
- SUBROUTINE pmc_send_to_server_real_r3( buf, n, server_rank, tag, ierr )
+ END SUBROUTINE pmc_recv_from_parent_real_r2
+
+
+
+ SUBROUTINE pmc_send_to_parent_real_r3( buf, n, parent_rank, tag, ierr )
 
     IMPLICIT NONE
@@ -254,16 +257,16 @@
     REAL(wp), DIMENSION(:,:,:), INTENT(IN) ::  buf          !<
     INTEGER, INTENT(IN)                    ::  n            !<
-    INTEGER, INTENT(IN)                    ::  server_rank  !<
+    INTEGER, INTENT(IN)                    ::  parent_rank  !<
     INTEGER, INTENT(IN)                    ::  tag          !<
     INTEGER, INTENT(OUT)                   ::  ierr         !<
 
     ierr = 0
-    CALL MPI_SEND( buf, n, MPI_REAL, server_rank, tag, m_to_server_comm, ierr )
-
- END SUBROUTINE pmc_send_to_server_real_r3
-
-
-
- SUBROUTINE pmc_recv_from_server_real_r3( buf, n, server_rank, tag, ierr )
+    CALL MPI_SEND( buf, n, MPI_REAL, parent_rank, tag, m_to_parent_comm, ierr )
+
+ END SUBROUTINE pmc_send_to_parent_real_r3
+
+
+
+ SUBROUTINE pmc_recv_from_parent_real_r3( buf, n, parent_rank, tag, ierr )
 
     IMPLICIT NONE
@@ -271,193 +274,193 @@
     REAL(wp), DIMENSION(:,:,:), INTENT(OUT) ::  buf          !<
     INTEGER, INTENT(IN)                     ::  n            !<
-    INTEGER, INTENT(IN)                     ::  server_rank  !<
+    INTEGER, INTENT(IN)                     ::  parent_rank  !<
     INTEGER, INTENT(IN)                     ::  tag          !<
     INTEGER, INTENT(OUT)                    ::  ierr         !<
 
     ierr = 0
-    CALL MPI_RECV( buf, n, MPI_REAL, server_rank, tag, m_to_server_comm,       &
+    CALL MPI_RECV( buf, n, MPI_REAL, parent_rank, tag, m_to_parent_comm,        &
                    MPI_STATUS_IGNORE, ierr )
 
- END SUBROUTINE pmc_recv_from_server_real_r3
-
-
-
- SUBROUTINE pmc_send_to_client_integer( client_id, buf, n, client_rank, tag,   &
-                                        ierr )
-
-    IMPLICIT NONE
-
-    INTEGER, INTENT(IN)               ::  client_id    !<
+ END SUBROUTINE pmc_recv_from_parent_real_r3
+
+
+
+ SUBROUTINE pmc_send_to_child_integer( child_id, buf, n, child_rank, tag,       &
+                                       ierr )
+
+    IMPLICIT NONE
+
+    INTEGER, INTENT(IN)               ::  child_id     !<
     INTEGER, DIMENSION(:), INTENT(IN) ::  buf          !<
     INTEGER, INTENT(IN)               ::  n            !<
-    INTEGER, INTENT(IN)               ::  client_rank  !<
+    INTEGER, INTENT(IN)               ::  child_rank   !<
     INTEGER, INTENT(IN)               ::  tag          !<
     INTEGER, INTENT(OUT)              ::  ierr         !<
 
     ierr = 0
-    CALL MPI_SEND( buf, n, MPI_INTEGER, client_rank, tag,                      &
-                   m_to_client_comm(client_id), ierr )
-
- END SUBROUTINE pmc_send_to_client_integer
-
-
-
- SUBROUTINE pmc_recv_from_client_integer( client_id, buf, n, client_rank, tag, &
-                                          ierr )
-
-    IMPLICIT NONE
-
-    INTEGER, INTENT(IN)                  ::  client_id    !<
+    CALL MPI_SEND( buf, n, MPI_INTEGER, child_rank, tag,                        &
+                   m_to_child_comm(child_id), ierr )
+
+ END SUBROUTINE pmc_send_to_child_integer
+
+
+
+ SUBROUTINE pmc_recv_from_child_integer( child_id, buf, n, child_rank, tag,     &
+                                         ierr )
+
+    IMPLICIT NONE
+
+    INTEGER, INTENT(IN)                  ::  child_id     !<
     INTEGER, DIMENSION(:), INTENT(INOUT) ::  buf          !<
     INTEGER, INTENT(IN)                  ::  n            !<
-    INTEGER, INTENT(IN)                  ::  client_rank  !<
+    INTEGER, INTENT(IN)                  ::  child_rank   !<
     INTEGER, INTENT(IN)                  ::  tag          !<
     INTEGER, INTENT(OUT)                 ::  ierr         !<
 
     ierr = 0
-    CALL MPI_RECV( buf, n, MPI_INTEGER, client_rank, tag,                      &
-                   m_to_client_comm(client_id), MPI_STATUS_IGNORE, ierr )
-
- END SUBROUTINE pmc_recv_from_client_integer
-
-
-
- SUBROUTINE pmc_recv_from_client_integer_2( client_id, buf, n, client_rank,    &
-                                            tag, ierr )
-
-    IMPLICIT NONE
-
-    INTEGER, INTENT(IN)                  ::  client_id    !<
+    CALL MPI_RECV( buf, n, MPI_INTEGER, child_rank, tag,                        &
+                   m_to_child_comm(child_id), MPI_STATUS_IGNORE, ierr )
+
+ END SUBROUTINE pmc_recv_from_child_integer
+
+
+
+ SUBROUTINE pmc_recv_from_child_integer_2( child_id, buf, n, child_rank,        &
+                                           tag, ierr )
+
+    IMPLICIT NONE
+
+    INTEGER, INTENT(IN)                  ::  child_id     !<
     INTEGER, DIMENSION(:,:), INTENT(OUT) ::  buf          !<
     INTEGER, INTENT(IN)                  ::  n            !<
-    INTEGER, INTENT(IN)                  ::  client_rank  !<
+    INTEGER, INTENT(IN)                  ::  child_rank   !<
     INTEGER, INTENT(IN)                  ::  tag          !<
     INTEGER, INTENT(OUT)                 ::  ierr         !<
 
     ierr = 0
-    CALL MPI_RECV( buf, n, MPI_INTEGER, client_rank, tag,                      &
-                   m_to_client_comm(client_id), MPI_STATUS_IGNORE, ierr )
-
- END SUBROUTINE pmc_recv_from_client_integer_2
-
-
-
- SUBROUTINE pmc_send_to_client_real_r1( client_id, buf, n, client_rank, tag,   &
-                                        ierr )
-
-    IMPLICIT NONE
-
-    INTEGER, INTENT(IN)                ::  client_id    !<
+    CALL MPI_RECV( buf, n, MPI_INTEGER, child_rank, tag,                        &
+                   m_to_child_comm(child_id), MPI_STATUS_IGNORE, ierr )
+
+ END SUBROUTINE pmc_recv_from_child_integer_2
+
+
+
+ SUBROUTINE pmc_send_to_child_real_r1( child_id, buf, n, child_rank, tag,       &
+                                       ierr )
+
+    IMPLICIT NONE
+
+    INTEGER, INTENT(IN)                ::  child_id     !<
     REAL(wp), DIMENSION(:), INTENT(IN) ::  buf          !<
     INTEGER, INTENT(IN)                ::  n            !<
-    INTEGER, INTENT(IN)                ::  client_rank  !<
+    INTEGER, INTENT(IN)                ::  child_rank   !<
     INTEGER, INTENT(IN)                ::  tag          !<
     INTEGER, INTENT(OUT)               ::  ierr         !<
 
     ierr = 0
-    CALL MPI_SEND( buf, n, MPI_REAL, client_rank, tag,                         &
-                   m_to_client_comm(client_id), ierr )
-
- END SUBROUTINE pmc_send_to_client_real_r1
-
-
-
- SUBROUTINE pmc_recv_from_client_real_r1( client_id, buf, n, client_rank, tag, &
-                                          ierr )
-
-    IMPLICIT NONE
-
-    INTEGER, INTENT(IN)                   ::  client_id    !<
+    CALL MPI_SEND( buf, n, MPI_REAL, child_rank, tag,                           &
+                   m_to_child_comm(child_id), ierr )
+
+ END SUBROUTINE pmc_send_to_child_real_r1
+
+
+
+ SUBROUTINE pmc_recv_from_child_real_r1( child_id, buf, n, child_rank, tag,     &
+                                         ierr )
+
+    IMPLICIT NONE
+
+    INTEGER, INTENT(IN)                   ::  child_id     !<
     REAL(wp), DIMENSION(:), INTENT(INOUT) ::  buf          !<
     INTEGER, INTENT(IN)                   ::  n            !<
-    INTEGER, INTENT(IN)                   ::  client_rank  !<
+    INTEGER, INTENT(IN)                   ::  child_rank   !<
     INTEGER, INTENT(IN)                   ::  tag          !<
     INTEGER, INTENT(OUT)                  ::  ierr         !<
 
     ierr = 0
-    CALL MPI_RECV( buf, n, MPI_REAL, client_rank, tag,                         &
-                   m_to_client_comm(client_id), MPI_STATUS_IGNORE, ierr )
-
- END SUBROUTINE pmc_recv_from_client_real_r1
-
-
-
- SUBROUTINE pmc_send_to_client_real_r2( client_id, buf, n, client_rank, tag,   &
-                                        ierr )
-
-    IMPLICIT NONE
-
-    INTEGER, INTENT(IN)                  ::  client_id    !<
+    CALL MPI_RECV( buf, n, MPI_REAL, child_rank, tag,                           &
+                   m_to_child_comm(child_id), MPI_STATUS_IGNORE, ierr )
+
+ END SUBROUTINE pmc_recv_from_child_real_r1
+
+
+
+ SUBROUTINE pmc_send_to_child_real_r2( child_id, buf, n, child_rank, tag,       &
+                                       ierr )
+
+    IMPLICIT NONE
+
+    INTEGER, INTENT(IN)                  ::  child_id     !<
     REAL(wp), DIMENSION(:,:), INTENT(IN) ::  buf          !<
     INTEGER, INTENT(IN)                  ::  n            !<
-    INTEGER, INTENT(IN)                  ::  client_rank  !<
+    INTEGER, INTENT(IN)                  ::  child_rank   !<
     INTEGER, INTENT(IN)                  ::  tag          !<
     INTEGER, INTENT(OUT)                 ::  ierr         !<
 
     ierr = 0
-    CALL MPI_SEND( buf, n, MPI_REAL, client_rank, tag,                         &
-                   m_to_client_comm(client_id), ierr )
-
- END SUBROUTINE pmc_send_to_client_real_r2
-
-
-
- SUBROUTINE pmc_recv_from_client_real_r2( client_id, buf, n, client_rank, tag, &
-                                          ierr )
-
-    IMPLICIT NONE
-
-    INTEGER, INTENT(IN)                   ::  client_id    !<
+    CALL MPI_SEND( buf, n, MPI_REAL, child_rank, tag,                           &
+                   m_to_child_comm(child_id), ierr )
+
+ END SUBROUTINE pmc_send_to_child_real_r2
+
+
+
+ SUBROUTINE pmc_recv_from_child_real_r2( child_id, buf, n, child_rank, tag,     &
+                                         ierr )
+
+    IMPLICIT NONE
+
+    INTEGER, INTENT(IN)                   ::  child_id     !<
     REAL(wp), DIMENSION(:,:), INTENT(OUT) ::  buf          !<
     INTEGER, INTENT(IN)                   ::  n            !<
-    INTEGER, INTENT(IN)                   ::  client_rank  !<
+    INTEGER, INTENT(IN)                   ::  child_rank   !<
     INTEGER, INTENT(IN)                   ::  tag          !<
     INTEGER, INTENT(OUT)                  ::  ierr         !<
 
     ierr = 0
-    CALL MPI_RECV( buf, n, MPI_REAL, client_rank, tag,                         &
-                   m_to_client_comm(client_id), MPI_STATUS_IGNORE, ierr )
-
- END SUBROUTINE pmc_recv_from_client_real_r2
-
-
-
- SUBROUTINE pmc_send_to_client_real_r3( client_id, buf, n, client_rank, tag,   &
-                                        ierr)
-
-    IMPLICIT NONE
-
-    INTEGER, INTENT(IN)                    ::  client_id    !<
+    CALL MPI_RECV( buf, n, MPI_REAL, child_rank, tag,                           &
+                   m_to_child_comm(child_id), MPI_STATUS_IGNORE, ierr )
+
+ END SUBROUTINE pmc_recv_from_child_real_r2
+
+
+
+ SUBROUTINE pmc_send_to_child_real_r3( child_id, buf, n, child_rank, tag,       &
+                                       ierr)
+
+    IMPLICIT NONE
+
+    INTEGER, INTENT(IN)                    ::  child_id     !<
     REAL(wp), DIMENSION(:,:,:), INTENT(IN) ::  buf          !<
     INTEGER, INTENT(IN)                    ::  n            !<
-    INTEGER, INTENT(IN)                    ::  client_rank  !<
+    INTEGER, INTENT(IN)                    ::  child_rank   !<
     INTEGER, INTENT(IN)                    ::  tag          !<
     INTEGER, INTENT(OUT)                   ::  ierr         !<
 
     ierr = 0
-    CALL MPI_SEND( buf, n, MPI_REAL, client_rank, tag,                         &
-                   m_to_client_comm(client_id), ierr )
-
- END SUBROUTINE pmc_send_to_client_real_r3
-
-
-
- SUBROUTINE pmc_recv_from_client_real_r3( client_id, buf, n, client_rank, tag, &
-                                          ierr )
-
-    IMPLICIT NONE
-
-    INTEGER, INTENT(IN)                     ::  client_id    !<
+    CALL MPI_SEND( buf, n, MPI_REAL, child_rank, tag,                           &
+                   m_to_child_comm(child_id), ierr )
+
+ END SUBROUTINE pmc_send_to_child_real_r3
+
+
+
+ SUBROUTINE pmc_recv_from_child_real_r3( child_id, buf, n, child_rank, tag,     &
+                                         ierr )
+
+    IMPLICIT NONE
+
+    INTEGER, INTENT(IN)                     ::  child_id     !<
     REAL(wp), DIMENSION(:,:,:), INTENT(OUT) ::  buf          !<
     INTEGER, INTENT(IN)                     ::  n            !<
-    INTEGER, INTENT(IN)                     ::  client_rank  !<
+    INTEGER, INTENT(IN)                     ::  child_rank   !<
     INTEGER, INTENT(IN)                     ::  tag          !<
     INTEGER, INTENT(OUT)                    ::  ierr         !<
 
     ierr = 0
-    CALL MPI_RECV( buf, n, MPI_REAL, client_rank, tag,                         &
-                   m_to_client_comm(client_id), MPI_STATUS_IGNORE, ierr )
-
- END SUBROUTINE pmc_recv_from_client_real_r3
+    CALL MPI_RECV( buf, n, MPI_REAL, child_rank, tag,                           & 
+                   m_to_child_comm(child_id), MPI_STATUS_IGNORE, ierr )
+
+ END SUBROUTINE pmc_recv_from_child_real_r3
 
 
@@ -520,10 +523,10 @@
 
 
- SUBROUTINE pmc_inter_bcast_integer_1( buf, client_id, ierr )
+ SUBROUTINE pmc_inter_bcast_integer_1( buf, child_id, ierr )
 
     IMPLICIT NONE
 
     INTEGER, INTENT(INOUT),DIMENSION(:) ::  buf        !<
-    INTEGER, INTENT(IN),optional        ::  client_id  !<
+    INTEGER, INTENT(IN),optional        ::  child_id   !<
     INTEGER, INTENT(OUT),optional       ::  ierr       !<
 
@@ -533,8 +536,8 @@
 
 !
-!-- PE 0 server broadcast to all client PEs
-    IF ( PRESENT( client_id ) )  THEN
-
-       mycomm = m_to_client_comm(client_id)
+!-- PE 0 on parent broadcast to all child PEs
+    IF ( PRESENT( child_id ) )  THEN
+
+       mycomm = m_to_child_comm(child_id)
 
        IF ( m_model_rank == 0 )  THEN
@@ -545,5 +548,5 @@
 
     ELSE
-       mycomm  = m_to_server_comm
+       mycomm  = m_to_parent_comm
        root_pe = 0
     ENDIF
